import{s as We,f as Oe,n as Ze,o as De}from"../chunks/scheduler.37c15a92.js";import{S as Je,i as Ke,g as a,s as r,r as at,m as p,H as it,A as Qe,h as i,f as e,c as m,j as c,u as lt,x as o,n as h,B as rt,k as T,y as l,a as n,v as mt,d as ot,t as pt,w as ht}from"../chunks/index.7cb9c9b8.js";import{H as Zt,E as Ve}from"../chunks/EditOnGithub.858acfec.js";function Xe(de){let u,gt,st,ct,L,ut,M,we="Before training our agent, we need to understand <strong>what ML-Agents is and how it works</strong>.",ft,$,vt,b,ye='<a href="https://github.com/Unity-Technologies/ml-agents" rel="nofollow">Unity ML-Agents</a> is a toolkit for the game engine Unity that <strong>allows us to create environments using Unity or use pre-made environments to train our agents</strong>.',dt,C,xe='It’s developed by <a href="https://unity.com/" rel="nofollow">Unity Technologies</a>, the developers of Unity, one of the most famous Game Engines used by the creators of Firewatch, Cuphead, and Cities: Skylines.',wt,k,_e='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit5/firewatch.jpeg" alt="Firewatch"/> <figcaption>Firewatch was made with Unity</figcaption>',yt,A,xt,H,Te="With Unity ML-Agents, you have six essential components:",_t,P,Le='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit5/mlagents-1.png" alt="MLAgents"/> <figcaption>Source: <a href="https://unity-technologies.github.io/ml-agents/">Unity ML-Agents Documentation</a></figcaption>',Tt,R,Me="<li>The first is the <em>Learning Environment</em>, which contains <strong>the Unity scene (the environment) and the environment elements</strong> (game characters).</li> <li>The second is the <em>Python Low-level API</em>, which contains <strong>the low-level Python interface for interacting and manipulating the environment</strong>. It’s the API we use to launch the training.</li> <li>Then, we have the <em>External Communicator</em> that <strong>connects the Learning Environment (made with C#) with the low level Python API (Python)</strong>.</li> <li>The <em>Python trainers</em>: the <strong>Reinforcement algorithms made with PyTorch (PPO, SAC…)</strong>.</li> <li>The <em>Gym wrapper</em>: to encapsulate the RL environment in a gym wrapper.</li> <li>The <em>PettingZoo wrapper</em>: PettingZoo is the multi-agents version of the gym wrapper.</li>",Lt,E,Mt,S,$e="Inside the Learning Component, we have <strong>two important elements</strong>:",$t,U,be="<li>The first is the <em>agent component</em>, the actor of the scene. We’ll <strong>train the agent by optimizing its policy</strong> (which will tell us what action to take in each state). The policy is called the <em>Brain</em>.</li> <li>Finally, there is the <em>Academy</em>. This component <strong>orchestrates agents and their decision-making processes</strong>. Think of this Academy as a teacher who handles Python API requests.</li>",bt,z,Ce="To better understand its role, let’s remember the RL process. This can be modeled as a loop that works like this:",Ct,I,ke='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/RL_process.jpg" alt="The RL process" width="100%"/> <figcaption>The RL Process: a loop of state, action, reward and next state</figcaption> <figcaption>Source: <a href="http://incompleteideas.net/book/RLbook2020.pdf">Reinforcement Learning: An Introduction, Richard Sutton and Andrew G. Barto</a></figcaption>',kt,G,Ae="Now, let’s imagine an agent learning to play a platform game. The RL process looks like this:",At,y,He,Ht,g,f,Dt,W,Jt,Pt,Ne='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mn>0</mn></msub></mrow><annotation encoding="application/x-tex">S_0</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Kt,Z,Pe="Environment",Qt,Vt,v,Xt,O,Yt,Rt,qe='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mn>0</mn></msub></mrow><annotation encoding="application/x-tex">S_0</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Et,te,D,ee,St,Fe='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>A</mi><mn>0</mn></msub></mrow><annotation encoding="application/x-tex">A_0</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',se,ne,d,ae,J,Re="new",ie,K,le,Ut,je='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mn>1</mn></msub></mrow><annotation encoding="application/x-tex">S_1</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">1</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',re,me,w,oe,Q,pe,zt,Be='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>R</mi><mn>1</mn></msub></mrow><annotation encoding="application/x-tex">R_1</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">1</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',he,V,Ee="(Positive Reward +1)",ge,It,N,Se="This RL loop outputs a sequence of <strong>state, action, reward and next state.</strong> The goal of the agent is to <strong>maximize the expected cumulative reward</strong>.",Gt,q,Ue="The Academy will be the one that will <strong>send the order to our Agents and ensure that agents are in sync</strong>:",Ot,F,ze="<li>Collect Observations</li> <li>Select your action using your policy</li> <li>Take the Action</li> <li>Reset if you reached the max step or if you’re done.</li>",Nt,x,Ie,qt,j,Ge="Now that we understand how ML-Agents works, <strong>we’re ready to train our agents.</strong>",Ft,B,jt,nt,Bt;return L=new Zt({props:{title:"How do Unity ML-Agents work?",local:"how-mlagents-works",headingTag:"h1"}}),$=new Zt({props:{title:"What is Unity ML-Agents?",local:"what-is-mlagents",headingTag:"h2"}}),A=new Zt({props:{title:"The six components",local:"six-components",headingTag:"h2"}}),E=new Zt({props:{title:"Inside the Learning Component",local:"inside-learning-component",headingTag:"h2"}}),B=new Ve({props:{source:"https://github.com/huggingface/deep-rl-class/blob/main/units/en/unit5/how-mlagents-works.mdx"}}),{c(){u=a("meta"),gt=r(),st=a("p"),ct=r(),at(L.$$.fragment),ut=r(),M=a("p"),M.innerHTML=we,ft=r(),at($.$$.fragment),vt=r(),b=a("p"),b.innerHTML=ye,dt=r(),C=a("p"),C.innerHTML=xe,wt=r(),k=a("figure"),k.innerHTML=_e,yt=r(),at(A.$$.fragment),xt=r(),H=a("p"),H.textContent=Te,_t=r(),P=a("figure"),P.innerHTML=Le,Tt=r(),R=a("ul"),R.innerHTML=Me,Lt=r(),at(E.$$.fragment),Mt=r(),S=a("p"),S.innerHTML=$e,$t=r(),U=a("ul"),U.innerHTML=be,bt=r(),z=a("p"),z.textContent=Ce,Ct=r(),I=a("figure"),I.innerHTML=ke,kt=r(),G=a("p"),G.textContent=Ae,At=r(),y=a("img"),Ht=r(),g=a("ul"),f=a("li"),Dt=p("Our Agent receives "),W=a("strong"),Jt=p("state "),Pt=new it(!1),Kt=p(" from the "),Z=a("strong"),Z.textContent=Pe,Qt=p(" — we receive the first frame of our game (Environment)."),Vt=r(),v=a("li"),Xt=p("Based on that "),O=a("strong"),Yt=p("state"),Rt=new it(!1),Et=p(","),te=p(" the Agent takes "),D=a("strong"),ee=p("action"),St=new it(!1),se=p(" — our Agent will move to the right."),ne=r(),d=a("li"),ae=p("The environment goes to a "),J=a("strong"),J.textContent=Re,ie=p(" "),K=a("strong"),le=p("state"),Ut=new it(!1),re=p(" — new frame."),me=r(),w=a("li"),oe=p("The environment gives some "),Q=a("strong"),pe=p("reward"),zt=new it(!1),he=p(" to the Agent — we’re not dead "),V=a("em"),V.textContent=Ee,ge=p("."),It=r(),N=a("p"),N.innerHTML=Se,Gt=r(),q=a("p"),q.innerHTML=Ue,Ot=r(),F=a("ul"),F.innerHTML=ze,Nt=r(),x=a("img"),qt=r(),j=a("p"),j.innerHTML=Ge,Ft=r(),at(B.$$.fragment),jt=r(),nt=a("p"),this.h()},l(t){const s=Qe("svelte-u9bgzb",document.head);u=i(s,"META",{name:!0,content:!0}),s.forEach(e),gt=m(t),st=i(t,"P",{}),c(st).forEach(e),ct=m(t),lt(L.$$.fragment,t),ut=m(t),M=i(t,"P",{"data-svelte-h":!0}),o(M)!=="svelte-15uedik"&&(M.innerHTML=we),ft=m(t),lt($.$$.fragment,t),vt=m(t),b=i(t,"P",{"data-svelte-h":!0}),o(b)!=="svelte-av0s9x"&&(b.innerHTML=ye),dt=m(t),C=i(t,"P",{"data-svelte-h":!0}),o(C)!=="svelte-fzslkd"&&(C.innerHTML=xe),wt=m(t),k=i(t,"FIGURE",{"data-svelte-h":!0}),o(k)!=="svelte-ymq6bm"&&(k.innerHTML=_e),yt=m(t),lt(A.$$.fragment,t),xt=m(t),H=i(t,"P",{"data-svelte-h":!0}),o(H)!=="svelte-dq339q"&&(H.textContent=Te),_t=m(t),P=i(t,"FIGURE",{"data-svelte-h":!0}),o(P)!=="svelte-10um3w0"&&(P.innerHTML=Le),Tt=m(t),R=i(t,"UL",{"data-svelte-h":!0}),o(R)!=="svelte-2em1lc"&&(R.innerHTML=Me),Lt=m(t),lt(E.$$.fragment,t),Mt=m(t),S=i(t,"P",{"data-svelte-h":!0}),o(S)!=="svelte-7x17zy"&&(S.innerHTML=$e),$t=m(t),U=i(t,"UL",{"data-svelte-h":!0}),o(U)!=="svelte-6e1ah7"&&(U.innerHTML=be),bt=m(t),z=i(t,"P",{"data-svelte-h":!0}),o(z)!=="svelte-1nodyfp"&&(z.textContent=Ce),Ct=m(t),I=i(t,"FIGURE",{"data-svelte-h":!0}),o(I)!=="svelte-ddctb4"&&(I.innerHTML=ke),kt=m(t),G=i(t,"P",{"data-svelte-h":!0}),o(G)!=="svelte-l0svdt"&&(G.textContent=Ae),At=m(t),y=i(t,"IMG",{src:!0,alt:!0,width:!0}),Ht=m(t),g=i(t,"UL",{});var _=c(g);f=i(_,"LI",{});var X=c(f);Dt=h(X,"Our Agent receives "),W=i(X,"STRONG",{});var ce=c(W);Jt=h(ce,"state "),Pt=rt(ce,!1),ce.forEach(e),Kt=h(X," from the "),Z=i(X,"STRONG",{"data-svelte-h":!0}),o(Z)!=="svelte-17f3im9"&&(Z.textContent=Pe),Qt=h(X," — we receive the first frame of our game (Environment)."),X.forEach(e),Vt=m(_),v=i(_,"LI",{});var Y=c(v);Xt=h(Y,"Based on that "),O=i(Y,"STRONG",{});var Wt=c(O);Yt=h(Wt,"state"),Rt=rt(Wt,!1),Et=h(Wt,","),Wt.forEach(e),te=h(Y," the Agent takes "),D=i(Y,"STRONG",{});var ue=c(D);ee=h(ue,"action"),St=rt(ue,!1),ue.forEach(e),se=h(Y," — our Agent will move to the right."),Y.forEach(e),ne=m(_),d=i(_,"LI",{});var tt=c(d);ae=h(tt,"The environment goes to a "),J=i(tt,"STRONG",{"data-svelte-h":!0}),o(J)!=="svelte-xvdw54"&&(J.textContent=Re),ie=h(tt," "),K=i(tt,"STRONG",{});var fe=c(K);le=h(fe,"state"),Ut=rt(fe,!1),fe.forEach(e),re=h(tt," — new frame."),tt.forEach(e),me=m(_),w=i(_,"LI",{});var et=c(w);oe=h(et,"The environment gives some "),Q=i(et,"STRONG",{});var ve=c(Q);pe=h(ve,"reward"),zt=rt(ve,!1),ve.forEach(e),he=h(et," to the Agent — we’re not dead "),V=i(et,"EM",{"data-svelte-h":!0}),o(V)!=="svelte-wepaxr"&&(V.textContent=Ee),ge=h(et,"."),et.forEach(e),_.forEach(e),It=m(t),N=i(t,"P",{"data-svelte-h":!0}),o(N)!=="svelte-3iun6t"&&(N.innerHTML=Se),Gt=m(t),q=i(t,"P",{"data-svelte-h":!0}),o(q)!=="svelte-1q61jnh"&&(q.innerHTML=Ue),Ot=m(t),F=i(t,"UL",{"data-svelte-h":!0}),o(F)!=="svelte-w2l7uo"&&(F.innerHTML=ze),Nt=m(t),x=i(t,"IMG",{src:!0,alt:!0,width:!0}),qt=m(t),j=i(t,"P",{"data-svelte-h":!0}),o(j)!=="svelte-1j4rf70"&&(j.innerHTML=Ge),Ft=m(t),lt(B.$$.fragment,t),jt=m(t),nt=i(t,"P",{}),c(nt).forEach(e),this.h()},h(){T(u,"name","hf:doc:metadata"),T(u,"content",Ye),Oe(y.src,He="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/RL_process_game.jpg")||T(y,"src",He),T(y,"alt","The RL process"),T(y,"width","100%"),Pt.a=null,Rt.a=Et,St.a=null,Ut.a=null,zt.a=null,Oe(x.src,Ie="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit5/academy.png")||T(x,"src",Ie),T(x,"alt","The MLAgents Academy"),T(x,"width","100%")},m(t,s){l(document.head,u),n(t,gt,s),n(t,st,s),n(t,ct,s),mt(L,t,s),n(t,ut,s),n(t,M,s),n(t,ft,s),mt($,t,s),n(t,vt,s),n(t,b,s),n(t,dt,s),n(t,C,s),n(t,wt,s),n(t,k,s),n(t,yt,s),mt(A,t,s),n(t,xt,s),n(t,H,s),n(t,_t,s),n(t,P,s),n(t,Tt,s),n(t,R,s),n(t,Lt,s),mt(E,t,s),n(t,Mt,s),n(t,S,s),n(t,$t,s),n(t,U,s),n(t,bt,s),n(t,z,s),n(t,Ct,s),n(t,I,s),n(t,kt,s),n(t,G,s),n(t,At,s),n(t,y,s),n(t,Ht,s),n(t,g,s),l(g,f),l(f,Dt),l(f,W),l(W,Jt),Pt.m(Ne,W),l(f,Kt),l(f,Z),l(f,Qt),l(g,Vt),l(g,v),l(v,Xt),l(v,O),l(O,Yt),Rt.m(qe,O),l(O,Et),l(v,te),l(v,D),l(D,ee),St.m(Fe,D),l(v,se),l(g,ne),l(g,d),l(d,ae),l(d,J),l(d,ie),l(d,K),l(K,le),Ut.m(je,K),l(d,re),l(g,me),l(g,w),l(w,oe),l(w,Q),l(Q,pe),zt.m(Be,Q),l(w,he),l(w,V),l(w,ge),n(t,It,s),n(t,N,s),n(t,Gt,s),n(t,q,s),n(t,Ot,s),n(t,F,s),n(t,Nt,s),n(t,x,s),n(t,qt,s),n(t,j,s),n(t,Ft,s),mt(B,t,s),n(t,jt,s),n(t,nt,s),Bt=!0},p:Ze,i(t){Bt||(ot(L.$$.fragment,t),ot($.$$.fragment,t),ot(A.$$.fragment,t),ot(E.$$.fragment,t),ot(B.$$.fragment,t),Bt=!0)},o(t){pt(L.$$.fragment,t),pt($.$$.fragment,t),pt(A.$$.fragment,t),pt(E.$$.fragment,t),pt(B.$$.fragment,t),Bt=!1},d(t){t&&(e(gt),e(st),e(ct),e(ut),e(M),e(ft),e(vt),e(b),e(dt),e(C),e(wt),e(k),e(yt),e(xt),e(H),e(_t),e(P),e(Tt),e(R),e(Lt),e(Mt),e(S),e($t),e(U),e(bt),e(z),e(Ct),e(I),e(kt),e(G),e(At),e(y),e(Ht),e(g),e(It),e(N),e(Gt),e(q),e(Ot),e(F),e(Nt),e(x),e(qt),e(j),e(Ft),e(jt),e(nt)),e(u),ht(L,t),ht($,t),ht(A,t),ht(E,t),ht(B,t)}}}const Ye='{"title":"How do Unity ML-Agents work?","local":"how-mlagents-works","sections":[{"title":"What is Unity ML-Agents?","local":"what-is-mlagents","sections":[],"depth":2},{"title":"The six components","local":"six-components","sections":[],"depth":2},{"title":"Inside the Learning Component","local":"inside-learning-component","sections":[],"depth":2}],"depth":1}';function ts(de){return De(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class as extends Je{constructor(u){super(),Ke(this,u,ts,Xe,We,{})}}export{as as component};
